From 8cd5c382bdbbae3bcef5b9efb427c04f030dbc4e Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sun, 5 Sep 2021 22:34:37 +0200
Subject: [PATCH] Remove the old vmm.

---
 Makefile_upgrade.inc                         |    5 +
 lib/libc/sys/Makefile.inc                    |    4 +-
 lib/libc/sys/Symbol.map                      |    6 -
 lib/libc/sys/vmm.2                           |   95 -
 share/man/man7/vkernel.7                     |    7 +-
 sys/conf/files                               |    1 -
 sys/kern/init_sysent.c                       |    4 +-
 sys/kern/kern_clock.c                        |    3 -
 sys/kern/kern_exit.c                         |    5 -
 sys/kern/kern_umtx.c                         |   14 -
 sys/kern/sys_vmm.c                           |  231 ---
 sys/kern/syscalls.c                          |    4 +-
 sys/kern/syscalls.master                     |    4 +-
 sys/platform/pc64/conf/files                 |   18 -
 sys/platform/pc64/include/vmm.h              |   48 -
 sys/platform/pc64/vmm/ept.c                  |  544 ------
 sys/platform/pc64/vmm/ept.h                  |  101 -
 sys/platform/pc64/vmm/svm.c                  |  171 --
 sys/platform/pc64/vmm/svm.h                  |   90 -
 sys/platform/pc64/vmm/vmm.c                  |  208 ---
 sys/platform/pc64/vmm/vmm.h                  |  101 -
 sys/platform/pc64/vmm/vmm_utils.c            |  173 --
 sys/platform/pc64/vmm/vmm_utils.h            |   52 -
 sys/platform/pc64/vmm/vmx.c                  | 1741 ------------------
 sys/platform/pc64/vmm/vmx.h                  |  335 ----
 sys/platform/pc64/vmm/vmx_genassym.c         |   72 -
 sys/platform/pc64/vmm/vmx_instr.h            |  164 --
 sys/platform/pc64/vmm/vmx_trap.s             |  200 --
 sys/platform/pc64/vmm/vmx_vmcs.h             |  215 ---
 sys/platform/pc64/x86_64/tls.c               |    5 -
 sys/platform/pc64/x86_64/vm_machdep.c        |   11 +-
 sys/platform/vkernel64/include/vmm.h         |   74 -
 sys/platform/vkernel64/platform/cothread.c   |   11 -
 sys/platform/vkernel64/platform/init.c       |  152 +-
 sys/platform/vkernel64/platform/pmap.c       |  102 +-
 sys/platform/vkernel64/platform/pmap_inval.c |  179 +-
 sys/platform/vkernel64/x86_64/mp.c           |   14 -
 sys/platform/vkernel64/x86_64/trap.c         |    6 +-
 sys/sys/param.h                              |    3 +-
 sys/sys/proc.h                               |    8 +-
 sys/sys/syscall.h                            |    4 +-
 sys/sys/syscall.mk                           |    2 -
 sys/sys/sysproto.h                           |   10 -
 sys/sys/sysunion.h                           |    2 -
 sys/sys/thread.h                             |    2 +-
 sys/sys/vmm.h                                |   61 -
 sys/vfs/procfs/procfs_mem.c                  |   13 -
 sys/vm/vm_glue.c                             |    8 -
 sys/vm/vm_vmspace.c                          |   82 +-
 test/vmm/Makefile                            |    5 -
 test/vmm/vmm_test.c                          |  111 --
 51 files changed, 72 insertions(+), 5409 deletions(-)
 delete mode 100644 lib/libc/sys/vmm.2
 delete mode 100644 sys/kern/sys_vmm.c
 delete mode 100644 sys/platform/pc64/include/vmm.h
 delete mode 100644 sys/platform/pc64/vmm/ept.c
 delete mode 100644 sys/platform/pc64/vmm/ept.h
 delete mode 100644 sys/platform/pc64/vmm/svm.c
 delete mode 100644 sys/platform/pc64/vmm/svm.h
 delete mode 100644 sys/platform/pc64/vmm/vmm.c
 delete mode 100644 sys/platform/pc64/vmm/vmm.h
 delete mode 100644 sys/platform/pc64/vmm/vmm_utils.c
 delete mode 100644 sys/platform/pc64/vmm/vmm_utils.h
 delete mode 100644 sys/platform/pc64/vmm/vmx.c
 delete mode 100644 sys/platform/pc64/vmm/vmx.h
 delete mode 100644 sys/platform/pc64/vmm/vmx_genassym.c
 delete mode 100644 sys/platform/pc64/vmm/vmx_instr.h
 delete mode 100644 sys/platform/pc64/vmm/vmx_trap.s
 delete mode 100644 sys/platform/pc64/vmm/vmx_vmcs.h
 delete mode 100644 sys/platform/vkernel64/include/vmm.h
 delete mode 100644 sys/sys/vmm.h
 delete mode 100644 test/vmm/Makefile
 delete mode 100644 test/vmm/vmm_test.c

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index d634bb2584f..cc2203e905c 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3914,6 +3914,11 @@ TO_REMOVE+=/usr/share/man/man8/ndisgen.8.gz
 TO_REMOVE+=/usr/share/misc/windrv_stub.c
 TO_REMOVE+=/usr/include/stand.h
 TO_REMOVE+=/usr/lib/libstand.a
+TO_REMOVE+=/usr/include/machine/vmm.h
+TO_REMOVE+=/usr/include/sys/vmm.h
+TO_REMOVE+=/usr/share/man/man2/vmm.2.gz
+TO_REMOVE+=/usr/share/man/man2/vmm_guest_ctl.2.gz
+TO_REMOVE+=/usr/share/man/man2/vmm_guest_sync_addr.2.gz
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/lib/libc/sys/Makefile.inc b/lib/libc/sys/Makefile.inc
index c16757f61d5..ea41cbb2c2f 100644
--- a/lib/libc/sys/Makefile.inc
+++ b/lib/libc/sys/Makefile.inc
@@ -100,7 +100,7 @@ MAN+=	_exit.2 accept.2 access.2 acct.2 adjtime.2 bind.2 \
 	truncate.2 tls.2 umask.2 umtx.2 undelete.2 \
 	unlink.2 unlinkat.2 utimensat.2 utimes.2 utrace.2 usched_set.2 \
 	uuidgen.2 \
-	varsym.2 vfork.2 vmm.2 vquotactl.2 wait.2 write.2
+	varsym.2 vfork.2 vquotactl.2 wait.2 write.2
 
 MLINKS+=accept.2 accept4.2
 MLINKS+=access.2 eaccess.2 \
@@ -234,8 +234,6 @@ MLINKS+=utimes.2 futimes.2 \
 MLINKS+=varsym.2 varsym_get.2 \
 	varsym.2 varsym_list.2 \
 	varsym.2 varsym_set.2
-MLINKS+=vmm.2 vmm_guest_ctl.2 \
-	vmm.2 vmm_guest_sync_addr.2
 MLINKS+=wait.2 wait3.2 \
 	wait.2 wait4.2 \
 	wait.2 wait6.2 \
diff --git a/sys/conf/files b/sys/conf/files
index 5303572285e..5a0e447a539 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1503,7 +1503,6 @@ kern/vfs_vfsops.c	standard
 kern/kern_threads.c	standard
 kern/vfs_aio.c		standard
 kern/subr_cpu_topology.c	standard
-kern/sys_vmm.c		standard
 vfs/deadfs/dead_vnops.c	standard
 vfs/fifofs/fifo_vnops.c	standard
 vfs/nullfs/null_vfsops.c	optional nullfs
diff --git a/sys/kern/init_sysent.c b/sys/kern/init_sysent.c
index 2dc0b600834..da361b04514 100644
--- a/sys/kern/init_sysent.c
+++ b/sys/kern/init_sysent.c
@@ -548,8 +548,8 @@ struct sysent sysent[] = {
 	{ AS(linkat_args), (sy_call_t *)sys_linkat },	/* 531 = linkat */
 	{ AS(eaccess_args), (sy_call_t *)sys_eaccess },	/* 532 = eaccess */
 	{ AS(lpathconf_args), (sy_call_t *)sys_lpathconf },	/* 533 = lpathconf */
-	{ AS(vmm_guest_ctl_args), (sy_call_t *)sys_vmm_guest_ctl },	/* 534 = vmm_guest_ctl */
-	{ AS(vmm_guest_sync_addr_args), (sy_call_t *)sys_vmm_guest_sync_addr },	/* 535 = vmm_guest_sync_addr */
+	{ 0, (sy_call_t *)sys_nosys },			/* 534 = obsolete vmm_guest_ctl */
+	{ 0, (sy_call_t *)sys_nosys },			/* 535 = obsolete vmm_guest_sync_addr */
 	{ AS(procctl_args), (sy_call_t *)sys_procctl },	/* 536 = procctl */
 	{ AS(chflagsat_args), (sy_call_t *)sys_chflagsat },	/* 537 = chflagsat */
 	{ AS(pipe2_args), (sy_call_t *)sys_pipe2 },	/* 538 = pipe2 */
diff --git a/sys/kern/kern_clock.c b/sys/kern/kern_clock.c
index c6b7016a0ec..f98fdf78ae7 100644
--- a/sys/kern/kern_clock.c
+++ b/sys/kern/kern_clock.c
@@ -1003,9 +1003,6 @@ statclock(systimer_t info, int in_ipi, struct intrframe *frame)
 			 * The vkernel doesn't do a good job providing trap
 			 * frames that we can test.  If the GDF_VIRTUSER
 			 * flag is set we probably interrupted user mode.
-			 *
-			 * We also use this flag on the host when entering
-			 * VMM mode.
 			 */
 			td->td_uticks += bump;
 
diff --git a/sys/kern/kern_exit.c b/sys/kern/kern_exit.c
index 13c63f74ae1..f26c8efc919 100644
--- a/sys/kern/kern_exit.c
+++ b/sys/kern/kern_exit.c
@@ -72,8 +72,6 @@
 #include <sys/refcount.h>
 #include <sys/spinlock2.h>
 
-#include <machine/vmm.h>
-
 static void reaplwps(void *context, int dummy);
 static void reaplwp(struct lwp *lp);
 static void killlwps(struct lwp *lp);
@@ -694,9 +692,6 @@ lwp_exit(int masterexit, void *waddr)
 	if (lp->lwp_vkernel)
 		vkernel_lwp_exit(lp);
 
-	if (td->td_vmm)
-		vmm_vmdestroy();
-
 	/*
 	 * Clean up select/poll support
 	 */
diff --git a/sys/kern/kern_umtx.c b/sys/kern/kern_umtx.c
index 6eda83a54af..bd759e9825f 100644
--- a/sys/kern/kern_umtx.c
+++ b/sys/kern/kern_umtx.c
@@ -67,8 +67,6 @@
 
 #include <vm/vm_page2.h>
 
-#include <machine/vmm.h>
-
 /*
  * Improve umtx performance by polling for 4000nS before going to sleep.
  * This can avoid many IPIs in typical pthreads mutex situations.
@@ -125,12 +123,6 @@ sys_umtx_sleep(struct sysmsg *sysmsg, const struct umtx_sleep_args *uap)
 	return (EINVAL);
     td = curthread;
 
-    if (td->td_vmm) {
-	register_t gpa;
-	vmm_vm_get_gpa(td->td_proc, &gpa, (register_t)ptr);
-	ptr = (const int *)gpa;
-    }
-
     uptr = __DEQUALIFY(void *, ptr);
     if ((vm_offset_t)uptr & (sizeof(int) - 1))
 	return EFAULT;
@@ -268,12 +260,6 @@ sys_umtx_wakeup(struct sysmsg *sysmsg, const struct umtx_wakeup_args *uap)
 
     td = curthread;
 
-    if (td->td_vmm) {
-	register_t gpa;
-	vmm_vm_get_gpa(td->td_proc, &gpa, (register_t)ptr);
-	ptr = (const int *)gpa;
-    }
-
     /*
      * WARNING! We can only use vm_fault_page*() for reading data.  We
      *		cannot use it for writing data because there is no pmap
diff --git a/sys/kern/syscalls.c b/sys/kern/syscalls.c
index efbc838c96a..a240012e4fd 100644
--- a/sys/kern/syscalls.c
+++ b/sys/kern/syscalls.c
@@ -540,8 +540,8 @@ const char *syscallnames[] = {
 	"linkat",			/* 531 = linkat */
 	"eaccess",			/* 532 = eaccess */
 	"lpathconf",			/* 533 = lpathconf */
-	"vmm_guest_ctl",			/* 534 = vmm_guest_ctl */
-	"vmm_guest_sync_addr",			/* 535 = vmm_guest_sync_addr */
+	"obs_vmm_guest_ctl",			/* 534 = obsolete vmm_guest_ctl */
+	"obs_vmm_guest_sync_addr",			/* 535 = obsolete vmm_guest_sync_addr */
 	"procctl",			/* 536 = procctl */
 	"chflagsat",			/* 537 = chflagsat */
 	"pipe2",			/* 538 = pipe2 */
diff --git a/sys/kern/syscalls.master b/sys/kern/syscalls.master
index b1d6ec01eb1..42e9283a3b8 100644
--- a/sys/kern/syscalls.master
+++ b/sys/kern/syscalls.master
@@ -715,8 +715,8 @@
 				char *path2, int flags); }
 532	STD	{ int eaccess(char *path, int flags); }
 533	STD	{ int lpathconf(char *path, int name); }
-534	STD	{ int vmm_guest_ctl(int op, struct vmm_guest_options *options); }
-535	STD	{ int vmm_guest_sync_addr(long *dstaddr, long *srcaddr); }
+534	OBSOL	vmm_guest_ctl
+535	OBSOL	vmm_guest_sync_addr
 536	STD	{ int procctl(idtype_t idtype, id_t id, int cmd, void *data); }
 537	STD	{ int chflagsat(int fd, const char *path, u_long flags, int atflags);}
 538	STD	{ int pipe2(int *fildes, int flags); }
diff --git a/sys/platform/pc64/conf/files b/sys/platform/pc64/conf/files
index fdf20203f1c..46c9fb9715f 100644
--- a/sys/platform/pc64/conf/files
+++ b/sys/platform/pc64/conf/files
@@ -205,24 +205,6 @@ bus/isa/vga_isa.c			optional	vga
 platform/pc64/isa/clock.c		standard
 platform/pc64/isa/isa_intr.c		optional	isa
 platform/pc64/x86_64/spinlock.s		standard
-
-vmx_genassym.o				standard					\
-	dependency 	" $S/platform/$P/vmm/vmx_genassym.c ${FORWARD_HEADERS_COOKIE}"	\
-	compile-with	"${CC} ${CFLAGS:N-fno-common:N-flto} -fcommon ${WERROR} -c ${.IMPSRC}" \
-	no-obj no-implicit-rule								\
-	clean		"vmx_genassym.o"
-vmx_assym.h				standard					\
-	dependency 	"$S/kern/genassym.sh vmx_genassym.o"				\
-	compile-with	"sh $S/kern/genassym.sh vmx_genassym.o > ${.TARGET}"		\
-	no-obj no-implicit-rule before-depend						\
-	clean		"vmx_assym.h"
-platform/pc64/vmm/vmm.c			standard
-platform/pc64/vmm/vmm_utils.c		standard
-# platform/pc64/vmm/vmx.c		standard
-# platform/pc64/vmm/ept.c		standard
-# platform/pc64/vmm/vmx_trap.s		standard
-# platform/pc64/vmm/svm.c		standard
-
 dev/virtual/hyperv/hyperv.c		standard
 dev/virtual/hyperv/hyperv_busdma.c	standard
 dev/virtual/hyperv/x86_64/hyperv_machdep.c	standard
diff --git a/sys/platform/pc64/x86_64/tls.c b/sys/platform/pc64/x86_64/tls.c
index 813065a21d6..349034b9378 100644
--- a/sys/platform/pc64/x86_64/tls.c
+++ b/sys/platform/pc64/x86_64/tls.c
@@ -55,7 +55,6 @@
 #include <machine/smp.h>
 #include <machine/pcb.h>
 #include <machine/thread.h>
-#include <machine/vmm.h>
 
 /*
  * set a TLS descriptor.  For x86_64 descriptor 0 identifies %fs and
@@ -172,10 +171,6 @@ set_user_TLS(void)
 		wrmsr(MSR_KGSBASE, gd->gd_user_gs);
 	}
 
-	if (td->td_vmm) {
-		vmm_vm_set_tls_area();
-	}
-
 	clear_quickret();
 	crit_exit_quick(td);
 }
diff --git a/sys/platform/pc64/x86_64/vm_machdep.c b/sys/platform/pc64/x86_64/vm_machdep.c
index 0e07207d075..0b0e2ed6bfc 100644
--- a/sys/platform/pc64/x86_64/vm_machdep.c
+++ b/sys/platform/pc64/x86_64/vm_machdep.c
@@ -64,7 +64,6 @@
 #include <machine/segments.h>
 #include <machine/globaldata.h>	/* npxthread */
 #include <machine/specialreg.h>
-#include <machine/vmm.h>
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -263,14 +262,8 @@ cpu_prepare_lwp(struct lwp *lp, struct lwp_params *params)
 	if (error)
 		return (error);
 
-	if (lp->lwp_proc->p_vmm) {
-		lp->lwp_thread->td_pcb->pcb_cr3 = KPML4phys;
-		cpu_set_fork_handler(lp,
-		    (void (*)(void *, struct trapframe *))vmm_lwp_return, lp);
-	} else {
-		cpu_set_fork_handler(lp,
-		    (void (*)(void *, struct trapframe *))generic_lwp_return, lp);
-	}
+	cpu_set_fork_handler(lp,
+	    (void (*)(void *, struct trapframe *))generic_lwp_return, lp);
 	return (0);
 }
 
diff --git a/sys/platform/vkernel64/platform/cothread.c b/sys/platform/vkernel64/platform/cothread.c
index 1de97e81dfa..2b43758c7fb 100644
--- a/sys/platform/vkernel64/platform/cothread.c
+++ b/sys/platform/vkernel64/platform/cothread.c
@@ -69,7 +69,6 @@
 #include <stdio.h>
 
 static void cothread_thread(void *arg);
-extern int vmm_enabled;
 
 /*
  * Create a co-processor thread for a virtual kernel.  This thread operates
@@ -82,7 +81,6 @@ cothread_create(void (*thr_func)(cothread_t cotd),
 		void *arg, const char *name)
 {
 	cothread_t cotd;
-	void *stack;
 	pthread_attr_t attr;
 
 	cotd = kmalloc(sizeof(*cotd), M_DEVBUF, M_WAITOK|M_ZERO);
@@ -107,15 +105,6 @@ cothread_create(void (*thr_func)(cothread_t cotd),
 	 * our coprocessor thread taking any unix signals :-)
 	 */
 	pthread_attr_init(&attr);
-	if (vmm_enabled) {
-		stack = mmap(NULL, KERNEL_STACK_SIZE,
-			     PROT_READ|PROT_WRITE|PROT_EXEC,
-			     MAP_ANON, -1, 0);
-		if (stack == MAP_FAILED) {
-			panic("Unable to allocate stack for cothread\n");
-		}
-		pthread_attr_setstack(&attr, stack, KERNEL_STACK_SIZE);
-	}
 	crit_enter();
 	cpu_mask_all_signals();
 	pthread_create(&cotd->pthr, &attr, (void *)cothread_thread, cotd);
diff --git a/sys/platform/vkernel64/platform/init.c b/sys/platform/vkernel64/platform/init.c
index 80e68da5892..76f01225242 100644
--- a/sys/platform/vkernel64/platform/init.c
+++ b/sys/platform/vkernel64/platform/init.c
@@ -53,7 +53,6 @@
 #include <vm/vm_map.h>
 #include <sys/mplock2.h>
 #include <sys/wait.h>
-#include <sys/vmm.h>
 
 #include <machine/cpu.h>
 #include <machine/globaldata.h>
@@ -123,7 +122,6 @@ int real_ncpus;		/* number of real CPUs */
 int next_cpu;		/* next real CPU to lock a virtual CPU to */
 int vkernel_b_arg;	/* no of logical CPU bits - only SMP */
 int vkernel_B_arg;	/* no of core bits - only SMP */
-int vmm_enabled;	/* VMM HW assisted enable */
 int use_precise_timer = 0;	/* use a precise timer (more expensive) */
 struct privatespace *CPU_prvspace;
 
@@ -137,7 +135,6 @@ static void *proc0paddr;
 
 static void init_sys_memory(char *imageFile);
 static void init_kern_memory(void);
-static void init_kern_memory_vmm(void);
 static void init_globaldata(void);
 static void init_vkernel(void);
 static void init_disk(char **diskExp, int *diskFlags, int diskFileNum, enum vkdisk_type type);
@@ -182,7 +179,6 @@ main(int ac, char **av)
 	int isq;
 	int pos;
 	int eflag;
-	int dflag = 0;		/* disable vmm */
 	int real_vkernel_enable;
 	int supports_sse;
 	uint32_t mxcsr_mask;
@@ -268,11 +264,8 @@ main(int ac, char **av)
 	if (ac < 2)
 		usage_help(false);
 
-	while ((c = getopt(ac, av, "c:hsvztTl:m:n:r:R:e:i:p:I:Ud")) != -1) {
+	while ((c = getopt(ac, av, "c:hsvztTl:m:n:r:R:e:i:p:I:U")) != -1) {
 		switch(c) {
-		case 'd':
-			dflag = 1;
-			break;
 		case 'e':
 			/*
 			 * name=value:name=value:name=value...
@@ -446,24 +439,10 @@ main(int ac, char **av)
 		}
 	}
 
-	/*
-	 * Check VMM presence
-	 */
-	vsize = sizeof(vmm_enabled);
-	sysctlbyname("hw.vmm.enable", &vmm_enabled, &vsize, NULL, 0);
-	vmm_enabled = (vmm_enabled && !dflag);
-
 	writepid();
 	cpu_disable_intr();
-	if (vmm_enabled) {
-		/* use a MAP_ANON directly */
-		printf("VMM is available\n");
-		init_kern_memory_vmm();
-	} else {
-		printf("VMM is not available\n");
-		init_sys_memory(memImageFile);
-		init_kern_memory();
-	}
+	init_sys_memory(memImageFile);
+	init_kern_memory();
 	init_globaldata();
 	init_vkernel();
 	setrealcpu();
@@ -732,131 +711,6 @@ init_kern_memory(void)
 	virtual_start += PAGE_SIZE;
 }
 
-static
-void
-init_kern_memory_vmm(void)
-{
-	int i;
-	void *firstfree;
-	struct vmm_guest_options options;
-	void *dmap_address;
-
-	KvaStart = (vm_offset_t)KERNEL_KVA_START;
-	KvaSize = KERNEL_KVA_SIZE;
-	KvaEnd = KvaStart + KvaSize;
-
-	Maxmem = Maxmem_bytes >> PAGE_SHIFT;
-	physmem = Maxmem;
-
-	if (Maxmem_bytes < 64 * 1024 * 1024 || (Maxmem_bytes & SEG_MASK)) {
-		errx(1, "Bad maxmem specification: 64MB minimum, "
-		       "multiples of %dMB only",
-		       SEG_SIZE / 1024 / 1024);
-		/* NOT REACHED */
-	}
-
-	/* Call the vmspace_create to allocate the internal
-	 * vkernel structures. Won't do anything else (no new
-	 * vmspace)
-	 */
-	if (vmspace_create(NULL, 0, NULL) < 0)
-		panic("vmspace_create() failed");
-
-
-	/*
-	 * MAP_ANON the region of the VKERNEL phyisical memory
-	 * (known as GPA - Guest Physical Address
-	 */
-	dmap_address = mmap(NULL, Maxmem_bytes,
-			    PROT_READ|PROT_WRITE|PROT_EXEC,
-			    MAP_ANON|MAP_SHARED, -1, 0);
-	if (dmap_address == MAP_FAILED) {
-		err(1, "Unable to mmap() RAM region!");
-		/* NOT REACHED */
-	}
-	if (prezeromem)
-		bzero(dmap_address, Maxmem_bytes);
-
-	/* Alloc a new stack in the lowmem */
-	vkernel_stack = mmap(NULL, KERNEL_STACK_SIZE,
-			     PROT_READ|PROT_WRITE|PROT_EXEC,
-			     MAP_ANON, -1, 0);
-	if (vkernel_stack == MAP_FAILED) {
-		err(1, "Unable to allocate stack\n");
-	}
-
-	/*
-	 * Bootstrap the kernel_pmap
-	 */
-	firstfree = dmap_address;
-	dmap_min_address = NULL; /* VIRT == PHYS in the first 512G */
-	pmap_bootstrap((vm_paddr_t *)&firstfree, (uint64_t)KvaStart);
-
-	/*
-	 * Enter VMM mode
-	 */
-	bzero(&options, sizeof(options));
-	options.guest_cr3 = (register_t) KPML4phys;
-	options.new_stack = (uint64_t) vkernel_stack + KERNEL_STACK_SIZE;
-	options.master = 1;
-	if (vmm_guest_ctl(VMM_GUEST_RUN, &options)) {
-		err(1, "Unable to enter VMM mode.");
-	}
-
-	/*
-	 * phys_avail[] represents unallocated physical memory.  MI code
-	 * will use phys_avail[] to create the vm_page array.
-	 */
-	phys_avail[0].phys_beg = (vm_paddr_t)firstfree;
-	phys_avail[0].phys_beg = (phys_avail[0].phys_beg + PAGE_MASK) &
-				 ~(vm_paddr_t)PAGE_MASK;
-	phys_avail[0].phys_end = (vm_paddr_t)dmap_address + Maxmem_bytes;
-
-	/*
-	 * pmap_growkernel() will set the correct value.
-	 */
-	kernel_vm_end = 0;
-
-	/*
-	 * Allocate space for process 0's UAREA.
-	 */
-	proc0paddr = (void *)virtual_start;
-	for (i = 0; i < UPAGES; ++i) {
-		pmap_kenter_quick(virtual_start, phys_avail[0].phys_beg);
-		virtual_start += PAGE_SIZE;
-		phys_avail[0].phys_beg += PAGE_SIZE;
-	}
-
-	/*
-	 * crashdumpmap
-	 */
-	crashdumpmap = virtual_start;
-	virtual_start += MAXDUMPPGS * PAGE_SIZE;
-
-	/*
-	 * msgbufp maps the system message buffer
-	 */
-	assert((MSGBUF_SIZE & PAGE_MASK) == 0);
-	msgbufp = (void *)virtual_start;
-	for (i = 0; i < (MSGBUF_SIZE >> PAGE_SHIFT); ++i) {
-
-		pmap_kenter_quick(virtual_start, phys_avail[0].phys_beg);
-		virtual_start += PAGE_SIZE;
-		phys_avail[0].phys_beg += PAGE_SIZE;
-	}
-
-	msgbufinit(msgbufp, MSGBUF_SIZE);
-
-	/*
-	 * used by kern_memio for /dev/mem access
-	 */
-	ptvmmap = (caddr_t)virtual_start;
-	virtual_start += PAGE_SIZE;
-
-	printf("vmm: Hardware pagetable enabled for guest\n");
-}
-
-
 /*
  * Map the per-cpu globaldata for cpu #0.  Allocate the space using
  * virtual_start and phys_avail[0]
diff --git a/sys/platform/vkernel64/platform/pmap.c b/sys/platform/vkernel64/platform/pmap.c
index 9d1353bede7..8cc2093acb3 100644
--- a/sys/platform/vkernel64/platform/pmap.c
+++ b/sys/platform/vkernel64/platform/pmap.c
@@ -140,7 +140,6 @@ static uint64_t	KPDphys;	/* phys addr of kernel level 2 */
 uint64_t		KPDPphys;	/* phys addr of kernel level 3 */
 uint64_t		KPML4phys;	/* phys addr of kernel level 4 */
 
-extern int vmm_enabled;
 extern void *vkernel_stack;
 
 /*
@@ -384,83 +383,6 @@ allocpages(vm_paddr_t *firstaddr, int n)
 	return (ret);
 }
 
-static void
-create_dmap_vmm(vm_paddr_t *firstaddr)
-{
-	void *stack_addr;
-	int pml4_stack_index;
-	int pdp_stack_index;
-	int pd_stack_index;
-	long i,j;
-	int regs[4];
-	int amd_feature;
-
-	uint64_t KPDP_DMAP_phys = allocpages(firstaddr, NDMPML4E);
-	uint64_t KPDP_VSTACK_phys = allocpages(firstaddr, 1);
-	uint64_t KPD_VSTACK_phys = allocpages(firstaddr, 1);
-
-	pml4_entry_t *KPML4virt = (pml4_entry_t *)PHYS_TO_DMAP(KPML4phys);
-	pdp_entry_t *KPDP_DMAP_virt = (pdp_entry_t *)PHYS_TO_DMAP(KPDP_DMAP_phys);
-	pdp_entry_t *KPDP_VSTACK_virt = (pdp_entry_t *)PHYS_TO_DMAP(KPDP_VSTACK_phys);
-	pd_entry_t *KPD_VSTACK_virt = (pd_entry_t *)PHYS_TO_DMAP(KPD_VSTACK_phys);
-
-	bzero(KPDP_DMAP_virt, NDMPML4E * PAGE_SIZE);
-	bzero(KPDP_VSTACK_virt, 1 * PAGE_SIZE);
-	bzero(KPD_VSTACK_virt, 1 * PAGE_SIZE);
-
-	do_cpuid(0x80000001, regs);
-	amd_feature = regs[3];
-
-	/* Build the mappings for the first 512GB */
-	if (amd_feature & AMDID_PAGE1GB) {
-		/* In pages of 1 GB, if supported */
-		for (i = 0; i < NPDPEPG; i++) {
-			KPDP_DMAP_virt[i] = ((uint64_t)i << PDPSHIFT);
-			KPDP_DMAP_virt[i] |= VPTE_RW | VPTE_V | VPTE_PS | VPTE_U;
-		}
-	} else {
-		/* In page of 2MB, otherwise */
-		for (i = 0; i < NPDPEPG; i++) {
-			uint64_t KPD_DMAP_phys;
-			pd_entry_t *KPD_DMAP_virt;
-
-			KPD_DMAP_phys = allocpages(firstaddr, 1);
-			KPD_DMAP_virt =
-				(pd_entry_t *)PHYS_TO_DMAP(KPD_DMAP_phys);
-
-			bzero(KPD_DMAP_virt, PAGE_SIZE);
-
-			KPDP_DMAP_virt[i] = KPD_DMAP_phys;
-			KPDP_DMAP_virt[i] |= VPTE_RW | VPTE_V | VPTE_U;
-
-			/* For each PD, we have to allocate NPTEPG PT */
-			for (j = 0; j < NPTEPG; j++) {
-				KPD_DMAP_virt[j] = (i << PDPSHIFT) |
-						   (j << PDRSHIFT);
-				KPD_DMAP_virt[j] |= VPTE_RW | VPTE_V |
-						    VPTE_PS | VPTE_U;
-			}
-		}
-	}
-
-	/* DMAP for the first 512G */
-	KPML4virt[0] = KPDP_DMAP_phys;
-	KPML4virt[0] |= VPTE_RW | VPTE_V | VPTE_U;
-
-	/* create a 2 MB map of the new stack */
-	pml4_stack_index = (uint64_t)&stack_addr >> PML4SHIFT;
-	KPML4virt[pml4_stack_index] = KPDP_VSTACK_phys;
-	KPML4virt[pml4_stack_index] |= VPTE_RW | VPTE_V | VPTE_U;
-
-	pdp_stack_index = ((uint64_t)&stack_addr & PML4MASK) >> PDPSHIFT;
-	KPDP_VSTACK_virt[pdp_stack_index] = KPD_VSTACK_phys;
-	KPDP_VSTACK_virt[pdp_stack_index] |= VPTE_RW | VPTE_V | VPTE_U;
-
-	pd_stack_index = ((uint64_t)&stack_addr & PDPMASK) >> PDRSHIFT;
-	KPD_VSTACK_virt[pd_stack_index] = (uint64_t) vkernel_stack;
-	KPD_VSTACK_virt[pd_stack_index] |= VPTE_RW | VPTE_V | VPTE_U | VPTE_PS;
-}
-
 static void
 create_pagetables(vm_paddr_t *firstaddr, int64_t ptov_offset)
 {
@@ -551,11 +473,6 @@ pmap_bootstrap(vm_paddr_t *firstaddr, int64_t ptov_offset)
 	 */
 	create_pagetables(firstaddr, ptov_offset);
 
-	/* Create the DMAP for the VMM */
-	if (vmm_enabled) {
-		create_dmap_vmm(firstaddr);
-	}
-
 	virtual_start = KvaStart;
 	virtual_end = KvaEnd;
 
@@ -617,10 +534,7 @@ pmap_bootstrap(vm_paddr_t *firstaddr, int64_t ptov_offset)
 	virtual_start = va;
 
 	*CMAP1 = 0;
-	/* Not ready to do an invltlb yet for VMM*/
-	if (!vmm_enabled)
-		cpu_invltlb();
-
+	cpu_invltlb();
 }
 
 /*
@@ -1735,13 +1649,6 @@ cpu_vmspace_alloc(struct vmspace *vm)
 	void *rp;
 	vpte_t vpte;
 
-	/*
-	 * If VMM enable, don't do nothing, we
-	 * are able to use real page tables
-	 */
-	if (vmm_enabled)
-		return;
-
 #define USER_SIZE	(VM_MAX_USER_ADDRESS - VM_MIN_USER_ADDRESS)
 
 	if (vmspace_create(&vm->vm_pmap, 0, NULL) < 0)
@@ -1766,13 +1673,6 @@ cpu_vmspace_alloc(struct vmspace *vm)
 void
 cpu_vmspace_free(struct vmspace *vm)
 {
-	/*
-	 * If VMM enable, don't do nothing, we
-	 * are able to use real page tables
-	 */
-	if (vmm_enabled)
-		return;
-
 	if (vmspace_destroy(&vm->vm_pmap) < 0)
 		panic("vmspace_destroy() failed");
 }
diff --git a/sys/platform/vkernel64/platform/pmap_inval.c b/sys/platform/vkernel64/platform/pmap_inval.c
index 56883e6102c..01170625e0e 100644
--- a/sys/platform/vkernel64/platform/pmap_inval.c
+++ b/sys/platform/vkernel64/platform/pmap_inval.c
@@ -30,8 +30,6 @@
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- * $DragonFly: src/sys/platform/vkernel/platform/pmap_inval.c,v 1.4 2007/07/02 02:22:58 dillon Exp $
  */
 
 /*
@@ -59,7 +57,6 @@
 #include <sys/cdefs.h>
 #include <sys/mman.h>
 #include <sys/vmspace.h>
-#include <sys/vmm.h>
 
 #include <vm/vm.h>
 #include <vm/pmap.h>
@@ -77,42 +74,8 @@
 
 #include <vm/vm_page2.h>
 
-extern int vmm_enabled;
-
-/*
- * Invalidate the TLB on the current cpu
- *
- * (VMM enabled only)
- */
-static __inline
-void
-vmm_cpu_invltlb(void)
-{
-#if 0
-	/* not directly supported */
-	cpu_invltlb();
-#else
-	/* vmm_guest_sync_addr(NULL, NULL); */
-	/* For VMM mode forces vmmexit/resume */
-	uint64_t rax = -1;
-	__asm __volatile("syscall;"
-			:
-			: "a" (rax)
-			:);
-#endif
-}
-
-static __inline
-void
-vmm_cpu_invlpg(void *addr __unused)
-{
-	vmm_cpu_invltlb();
-}
-
 /*
  * Invalidate va in the TLB on the current cpu
- *
- * (VMM disabled only)
  */
 static __inline
 void
@@ -125,69 +88,6 @@ pmap_inval_cpu(struct pmap *pmap, vm_offset_t va, size_t bytes)
 	}
 }
 
-/*
- * This is a bit of a mess because we don't know what virtual cpus are
- * mapped to real cpus.  Basically try to optimize the degenerate cases
- * (primarily related to user processes with only one thread or only one
- * running thread), and shunt all the rest to the host cpu.  The host cpu
- * will invalidate all real cpu's the vkernel is running on.
- *
- * This can't optimize situations where a pmap is only mapped to some of
- * the virtual cpus, though shunting to the real host will still be faster
- * if the virtual kernel processes are running on fewer real-host cpus.
- * (And probably will be faster anyway since there's no round-trip signaling
- * overhead).
- *
- * NOTE: The critical section protects against preemption while the pmap
- *	 is locked, which could otherwise result in a deadlock.
- */
-static __inline
-void
-guest_sync_addr(struct pmap *pmap, volatile vpte_t *ptep, vpte_t *srcv)
-{
-	globaldata_t gd = mycpu;
-	cpulock_t olock;
-	cpulock_t nlock;
-
-	/*
-	 * Lock the pmap
-	 */
-	crit_enter();
-	for (;;) {
-		olock = pmap->pm_active_lock;
-		cpu_ccfence();
-		if ((olock & CPULOCK_EXCL) == 0) {
-			nlock = olock | CPULOCK_EXCL;
-			if (atomic_cmpset_int(&pmap->pm_active_lock,
-					      olock, nlock)) {
-				break;
-			}
-		}
-		cpu_pause();
-		lwkt_process_ipiq();
-		vkernel_yield();
-	}
-
-	/*
-	 * Update the pte and synchronize with other cpus.  If we can update
-	 * it trivially, do so.
-	 */
-	if (CPUMASK_TESTZERO(pmap->pm_active) ||
-	    CPUMASK_CMPMASKEQ(pmap->pm_active, gd->gd_cpumask)) {
-		if (ptep)
-			*srcv = atomic_swap_long(ptep, *srcv);
-		vmm_cpu_invltlb();
-	} else {
-		vmm_guest_sync_addr(__DEVOLATILE(void *, ptep), srcv);
-	}
-
-	/*
-	 * Unlock the pmap
-	 */
-	atomic_clear_int(&pmap->pm_active_lock, CPULOCK_EXCL);
-	crit_exit();
-}
-
 /*
  * Invalidate a pte in a pmap and synchronize with target cpus
  * as required.  Throw away the modified and access bits.  Use
@@ -202,15 +102,8 @@ guest_sync_addr(struct pmap *pmap, volatile vpte_t *ptep, vpte_t *srcv)
 void
 pmap_inval_pte(volatile vpte_t *ptep, struct pmap *pmap, vm_offset_t va)
 {
-	vpte_t pte;
-
-	if (vmm_enabled == 0) {
-		atomic_swap_long(ptep, 0);
-		pmap_inval_cpu(pmap, va, PAGE_SIZE);
-	} else {
-		pte = 0;
-		guest_sync_addr(pmap, ptep, &pte);
-	}
+	atomic_swap_long(ptep, 0);
+	pmap_inval_cpu(pmap, va, PAGE_SIZE);
 }
 
 /*
@@ -221,10 +114,7 @@ void
 pmap_inval_pte_quick(volatile vpte_t *ptep, struct pmap *pmap, vm_offset_t va)
 {
 	atomic_swap_long(ptep, 0);
-	if (vmm_enabled == 0)
-		pmap_inval_cpu(pmap, va, PAGE_SIZE);
-	else
-		vmm_cpu_invltlb();
+	pmap_inval_cpu(pmap, va, PAGE_SIZE);
 }
 
 /*
@@ -234,11 +124,7 @@ pmap_inval_pte_quick(volatile vpte_t *ptep, struct pmap *pmap, vm_offset_t va)
 void
 pmap_invalidate_range(pmap_t pmap, vm_offset_t sva, vm_offset_t eva)
 {
-	if (vmm_enabled == 0) {
-		pmap_inval_cpu(pmap, sva, eva - sva);
-	} else {
-		guest_sync_addr(pmap, NULL, NULL);
-	}
+	pmap_inval_cpu(pmap, sva, eva - sva);
 }
 
 /*
@@ -249,19 +135,8 @@ pmap_invalidate_range(pmap_t pmap, vm_offset_t sva, vm_offset_t eva)
 void
 pmap_inval_pde(volatile vpte_t *ptep, struct pmap *pmap, vm_offset_t va)
 {
-	vpte_t pte;
-
-	if (vmm_enabled == 0) {
-		atomic_swap_long(ptep, 0);
-		pmap_inval_cpu(pmap, va, SEG_SIZE);
-	} else if (CPUMASK_TESTMASK(pmap->pm_active,
-				    mycpu->gd_other_cpus) == 0) {
-		atomic_swap_long(ptep, 0);
-		vmm_cpu_invltlb();
-	} else {
-		pte = 0;
-		guest_sync_addr(pmap, ptep, &pte);
-	}
+	atomic_swap_long(ptep, 0);
+	pmap_inval_cpu(pmap, va, SEG_SIZE);
 }
 
 void
@@ -333,22 +208,15 @@ pmap_clean_pte(volatile vpte_t *ptep, struct pmap *pmap, vm_offset_t va,
 		break;
 	}
 
-	if (vmm_enabled == 0) {
-		for (;;) {
-			pte = *ptep;
-			cpu_ccfence();
-			if ((pte & VPTE_RW) == 0)
-				break;
-			if (atomic_cmpset_long(ptep,
-					       pte,
-					       pte & ~(VPTE_RW | VPTE_M))) {
-				pmap_inval_cpu(pmap, va, PAGE_SIZE);
-				break;
-			}
+	for (;;) {
+		pte = *ptep;
+		cpu_ccfence();
+		if ((pte & VPTE_RW) == 0)
+			break;
+		if (atomic_cmpset_long(ptep, pte, pte & ~(VPTE_RW | VPTE_M))) {
+			pmap_inval_cpu(pmap, va, PAGE_SIZE);
+			break;
 		}
-	} else {
-		pte = *ptep & ~(VPTE_RW | VPTE_M);
-		guest_sync_addr(pmap, ptep, &pte);
 	}
 
 	if (m) {
@@ -377,32 +245,21 @@ pmap_inval_loadandclear(volatile vpte_t *ptep, struct pmap *pmap,
 {
 	vpte_t pte;
 
-	if (vmm_enabled == 0) {
-		pte = atomic_swap_long(ptep, 0);
-		pmap_inval_cpu(pmap, va, PAGE_SIZE);
-	} else {
-		pte = 0;
-		guest_sync_addr(pmap, ptep, &pte);
-	}
+	pte = atomic_swap_long(ptep, 0);
+	pmap_inval_cpu(pmap, va, PAGE_SIZE);
 	return(pte);
 }
 
 void
 cpu_invlpg(void *addr)
 {
-	if (vmm_enabled)
-		vmm_cpu_invlpg(addr);
-	else
-		madvise(addr, PAGE_SIZE, MADV_INVAL);
+	madvise(addr, PAGE_SIZE, MADV_INVAL);
 }
 
 void
 cpu_invltlb(void)
 {
-	if (vmm_enabled)
-		vmm_cpu_invltlb(); /* For VMM mode forces vmmexit/resume */
-	else
-		madvise((void *)KvaStart, KvaEnd - KvaStart, MADV_INVAL);
+	madvise((void *)KvaStart, KvaEnd - KvaStart, MADV_INVAL);
 }
 
 /*
